from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="PlayoutSchedule")


@attr.s(auto_attribs=True)
class PlayoutSchedule:
    """
    Attributes:
        id (int):
        default_playlist_id (Union[Unset, None, int]): A tank ID in case the timeslot's playlist_id is empty.
    """

    id: int
    default_playlist_id: Union[Unset, None, int] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        id = self.id
        default_playlist_id = self.default_playlist_id

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "id": id,
            }
        )
        if default_playlist_id is not UNSET:
            field_dict["defaultPlaylistId"] = default_playlist_id

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        id = d.pop("id")

        default_playlist_id = d.pop("defaultPlaylistId", UNSET)

        playout_schedule = cls(
            id=id,
            default_playlist_id=default_playlist_id,
        )

        playout_schedule.additional_properties = d
        return playout_schedule

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
